function [alpha,PT]=pro_multiPCAlp(d,r,gamma,lambda,X,k,t)
% the linear combination of multiview nonlinear projection
% d: the number of low dimensionality space features
% r: adjustment factor
% gamma: trade-off factor
% X: different view samples
% Y: projection samples
% alpha: linear combination coefficient
v=size(X,2);%multiviews
n=size(X{1},1);
alpha=ones(v,1)/v;

W=quanzhong2(X,k,t);

for i=1:v
    M{i}=tr1(X{i},W{i},gamma,lambda);
end
Hn=eye(n)-ones(n)/n;
for i=1:10%iteration
%    tic
    MM=zeros(n);
    for j=1:v
        MM=MM+(alpha(j)^r)*M{j};
    end
%    [vec,val]=eig(MM,Hn);%inverse
    [vec,val]=eig((Hn+0.0001*eye(n))\MM);%AȫֵɶԽvalAvec
    %A/BȼA*inv(B) B\Aȼinv(B)*A  inv(X) 㷽 X  
%    [vec,val]=eig(Hn\MM);
    [~,ind]=sort(diag(val));%diag(x)xm*nľaΪxԽԪɵaĴСxСά
    %sort(A)AлĬ϶ǶAСsort(A)Ĭϵ򣬶sort(A,'descend')ǽ
    %ǰ [sA,index] = sort(A) sAõindex  sA ж A 
    sind=ind(1:d);
    Y=(vec(:,sind))';
    obj(i)=trace(Y*MM*Y');%objective function
%     if i==7%%%
%         break;
%     end
    for j=1:v
        trc(j)=trace(Y*M{j}*Y');
        a(j)=(1/trc(j))^(1/(r-1));
    end
    b=sum(a);
    alpha=a/b;    
%    toc
end
Y=real(Y);
for i=1:v
    m=size(X{i},2);
    Im=eye(m);
    PT{i}=(Y*X{i})/((X{i}'*X{i})+gamma*Im);
end

%-----subfunction-----%
function M=tr1(X,W,gamma,lambda)
[n,m]=size(X);
Im=eye(m);
In=eye(n);
U=ones(n)/n-In;
V=In-X/(X'*X+gamma*Im)*X';
d=sum(W,2);
D=diag(d);
M=U+V+lambda*(D-W);

function W=quanzhong2(Xtrain,k,t)
v=size(Xtrain,2);
n=size(Xtrain{1},1);
for i=1:v
    for j=1:n
    e{i}{j} =KNN(Xtrain{i}(j,:),Xtrain{i},k);
    end
end
for j=1:n
    for i=1:(v-1)
        f{j}=intersect(e{i}{j},e{i+1}{j});
    end
end
for d=1:v
    a=zeros(n,n);
    W{d}=a;
    for i=1:n
        for j=1:length(f{i})
            W{d}(i,f{i}(j))=exp(-(norm(Xtrain{d}(i,:)-Xtrain{d}(f{i}(j),:))^2)/t);
            W{d}(f{i}(j),i)=exp(-(norm(Xtrain{d}(i,:)-Xtrain{d}(f{i}(j),:))^2)/t);
        end
    end
end

function [e] =KNN(in,test,k)
% in:       training samples data
% test:     testing data
% target:   k-nearist neighbors given by knn
% k:        the number of neighbors
dist=zeros(size(test,1),1);
for i=1:size(test,1)
     dist(i)=norm(in-test(i,:),2);
end   
[sdist,index]=sort(dist);
e=index(2:k+1);
% x=sdist(2:(k+1));
% y=index(2:(k+1));