function [alpha,PT]=pro_multiPCA(d,r,beta,gamma,X)
% the linear combination of multiview nonlinear projection
% d: the number of low dimensionality space features
% r: adjustment factor
% beta,gamma: trade-off factor
% X: different view samples
% Y: projection samples
% alpha: linear combination coefficient
v=size(X,2);%multiviewsά
n=size(X{1},1);
alpha=ones(v,1)/v;
for i=1:v
    M{i}=tr(X{i},beta,gamma);
end
Hn=eye(n)-ones(n)/n;
%%%MM=zeros(n);%%%
for i=1:50%iteration
%    tic
    MM=zeros(n);
    for j=1:v %Y
        MM=MM+(alpha(j)^r)*M{j};
    end
%    [vec,val]=eig(MM,Hn);%inverse
    [vec,val]=eig((Hn+0.0001*eye(n))\MM);%AȫֵɶԽvalAvec
    %A/BȼA*inv(B) B\Aȼinv(B)*A  inv(X) 㷽 X  
%    [vec,val]=eig(Hn\MM);
    [~,ind]=sort(diag(val));%diag(x)xm*nľaΪxԽԪɵaĴСxСά
    %sort(A)AлĬ϶ǶAСsort(A)Ĭϵ򣬶sort(A,'descend')ǽ
    %ǰ [sA,index] = sort(A) sAõindex  sA ж A 
    sind=ind(1:d);
    Y=(vec(:,sind))';
    obj(i)=trace(Y*MM*Y');%objective function
    if i==7%%%͵7
        break;
    end
    for j=1:v %²
        trc(j)=trace(Y*M{j}*Y');
        a(j)=(1/trc(j))^(1/(r-1));
    end
    b=sum(a);
    alpha=a/b;    
%    toc
end
Y=real(Y); %ʵ
for i=1:v %PT
    m=size(X{i},2);
    Im=eye(m);
    PT{i}=(beta*Y*X{i})/(beta*(X{i}'*X{i})+gamma*Im);
end
 
%-----subfunction-----%
function M=tr(X,beta,gamma) %Ż⼣ 4-18
[n,m]=size(X);
Im=eye(m);
In=eye(n);
V=In-X/(beta*(X'*X)+gamma*Im)*X';
U=ones(n)/n-In;
M=U+V*(beta^3)/2;

